﻿<?php
/*
Plugin Name: Super Cool QRCode
Plugin URI: http://www.incerteza.org/blog/projetos/super-cool-qrcode/
Description: Easily insert <a href="http://en.wikipedia.org/wiki/QR_Code" target="_blank">QR codes</a> anywhere in your blog.
Author: matias s
Version: 0.0.6
Author URI: http://www.incerteza.org/blog/
*/

/*
Copyright 2008  Matias Schertel  (email : matias@incerteza.org)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
// Global Variables
$sqr_dom = "super-cool-qrcodes";
$sqr_plug = get_settings("siteurl") . "/wp-content/plugins/super-cool-qrcodes/";

// DEFAULT OPTIONS
function sqr_default_opt() {
	$setup = array(
		'widget' => array(
			'title' => 'Super Cool QRCode',
			'cont' => '',
			'before' => '<div align="center">',
			'after' => '</div>',
			'size' => '125',
			'enc' => 'UTF-8',
			'ec' => 'L',
			'margin' => '2',
			'link' => 'false',
			'target' => '_blank',
			'border' => '0',
		),
		'shortcode' => array(
			'size' => '125',
			'enc' => 'UTF-8',
			'ec' => 'L',
			'margin' => '2',
			'link' => 'false',
			'target' => '_blank',
			'border' => '0',
		)
	);
	return $setup;
}

// ACTIVATION
register_activation_hook(__FILE__, 'sqr_activate');
function sqr_activate() {
	$opt = get_option("sqr_setup");
	if ( !is_array($opt) ) {
		$setup = sqr_default_opt();
		add_option('sqr_options', $setup);
	} else {
		//update_option('sqr_options', $setup);
	}
}

// DEACTIVATION
register_deactivation_hook(__FILE__, 'sqr_deactivate');
function sqr_deactivate() {
	delete_option('sqr_options');
}

// FUNCTION: curURL - return the current url
function curURL() {
	$pageURL = 'http';
	if ( $_SERVER["HTTPS"] == "on" ) { $pageURL .= "s"; }
 	$pageURL .= "://";
 	if ( $_SERVER["SERVER_PORT"] != "80" ) {
  		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} else {
  		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $pageURL;
}

// FUNCTION: delODD - remove strange chars
function delODD($str) {
	$find[] = '“';  // left side double smart quote
	$find[] = '”';  // right side double smart quote
	$find[] = '‘';  // left side single smart quote
	$find[] = '’';  // right side single smart quote
	$find[] = '…';  // elipsis
	$find[] = '—';  // em dash
	$find[] = '–';  // en dash
	$replace[] = '"';
	$replace[] = '"';
	$replace[] = "'";
	$replace[] = "'";
	$replace[] = "...";
	$replace[] = "-";
	$replace[] = "-";
	return str_replace($find, $replace, $str);
}

// FUNCTION: sqr_url(CONTENT,SIZE,ENCODING,ERRORCORRECTION,MARGIN) - only content is needed - return the img url
function sqr_url($cont='null', $size='125', $enc='UTF-8', $err='L', $mar='2') {
	$url = 'http://chart.apis.google.com/chart?chs=' . $size . 'x' . $size . '&cht=qr&chl=' . urlencode($cont) . '&choe=' . $enc . '&chld=' . $err . '|' . $mar;
	return $url;
}

// SHORTCODE [sqrcode]content[/sqrcode]
add_shortcode('sqrcode', 'sqr_shortcode');
function sqr_shortcode($atts, $content=null) {
$opt = get_option('sqr_options');
$opt = $opt['shortcode'];
	extract(shortcode_atts(array(  
		'size' => $opt['size'],
		'enc' => $opt['enc'],
		'ec' => $opt['ec'],
		'margin' => $opt['margin'],
		'link' => $opt['link'],
		'target' => $opt['target'],
		'border' => $opt['border'],
	), $atts));
	if ( $content == NULL || $content == '' ) {
		$content = curURL();
	}
	$content = delODD(html_entity_decode($content, ENT_QUOTES, 'UTF-8'));
	if ( $link == 'false' ) {
		return '<img src="' . sqr_url($content, $size, $enc, $ec, $margin) . '" alt="' . $content . '" width="' . $size . '" height="' . $size . '" border="' . $border . '" />';
	} else if ( $link == 'true' ) {
		return '<a href="' . sqr_url($content, $size, $enc, $ec, $margin) . '" target="' . $target . '"><img src="' . sqr_url($content,$size,$enc,$ec,$margin) . '" alt="' . $content . '" width="' . $size . '" height="' . $size . '" border="' . $border . '" /></a>';
	} else {
		return '<a href="' . $link . '" target="' . $target . '"><img src="' . sqr_url($content,$size,$enc,$err,$mar) . '" alt="' . $content . '" width="' . $size . '" height="' . $size . '" border="' . $border . '" /></a>';
	}
}

// WIDGET
add_action('widgets_init', 'sqr_widget_init');
function sqr_widget_init() {
	wp_register_sidebar_widget('sqr_widget', 'Super Cool QRCode', 'sqr_widget');
	register_widget_control('sqr_widget', 'sqr_control');
}
// Widget
function sqr_widget($args) {
	extract($args);
	$opt = get_option('sqr_options');
	$opt = $opt['widget'];
	$content = $opt['cont'];
	if ( $content == '' || $content == NULL ) {
		$content = curURL();
	}
	$content = delODD(html_entity_decode($content, ENT_QUOTES, 'UTF-8'));
	echo $before_widget;
	echo $before_title;
	echo $opt['title'];
	echo $after_title;
	echo $opt['before'];
	if ( $opt['link'] == 'false' ) {
		echo '<img src="' . sqr_url($content, $opt['size'], $opt['enc'], $opt['ec'], $opt['margin']) . '" alt="' . $content . '" width="' . $opt['size'] . '" height="' . $opt['size'] . '" border="' . $opt['border'] . '" />';
	} else if ( $opt['link'] == 'true' ) {
		echo '<a href="' . sqr_url($content, $opt['size'], $opt['enc'], $opt['ec'], $opt['margin']) . '" target="' . $opt['target'] . '"><img src="' . sqr_url($content, $opt['size'], $opt['enc'], $opt['ec'], $opt['margin']) . '" alt="' . $content . '" width="' . $opt['size'] . '" height="' . $opt['size'] . '" border="' . $opt['border'] . '" /></a>';
	} else {
		echo '<a href="' . $opt['link'] . '" target="' . $opt['target'] . '"><img src="' . sqr_url($content, $opt['size'], $opt['enc'], $opt['ec'], $opt['margin']) . '" alt="' . $content . '" width="' . $opt['size'] . '" height="' . $opt['size'] . '" border="' . $opt['border'] . '" /></a>';
	}
	echo $opt['after'];
	echo $after_widget;
}

// Widget control
function sqr_control() {
	$opt = get_option('sqr_options');
	if ( $_POST['sqr-submit'] ) {
		if ( $_POST['sqr-title'] != '' ) { $opt['widget']['title'] = stripslashes($_POST['sqr-title']); }
		if ( $_POST['sqr-before'] != '' ) { $opt['widget']['before'] = stripslashes($_POST['sqr-before']); }
		if ( $_POST['sqr-cont'] != '' ) { $opt['widget']['cont'] = stripslashes($_POST['sqr-cont']); }
			else { $opt['widget']['cont'] = ''; }
		if ( $_POST['sqr-after'] != '' ) { $opt['widget']['after'] = stripslashes($_POST['sqr-after']); }
		update_option('sqr_options', $opt);
	}
?>
	<p><label>Title: <input id="sqr_title" class="widefat" type="text" value="<?php echo htmlspecialchars($opt['widget']['title']); ?>" name="sqr-title"></p>
    <p><label>Before QRCode: <input id="sqr_before" class="widefat" type="text" value="<?php echo htmlspecialchars($opt['widget']['before']); ?>" name="sqr-before"></p>
    <p><label>Content (blank for current url): <input id="sqr_cont" class="widefat" type="text" value="<?php echo htmlspecialchars($opt['widget']['cont']); ?>" name="sqr-cont"></p>
    <p><label>After QRCode: <input id="sqr_after" class="widefat" type="text" value="<?php echo htmlspecialchars($opt['widget']['after']); ?>" name="sqr-after"></p>
    <input type="hidden" id="sqr_submit" name="sqr-submit" value="1" />
<?php
}

// SETTINGS link @ Plugin list page
add_filter( 'plugin_action_links', 'sqrcode_plugin_actions', 10, 2 );
function sqrcode_plugin_actions($links, $file){
global $sqr_dom;
	static $this_plugin;
 	if( !$this_plugin ) $this_plugin = plugin_basename(__FILE__);
 	if( $file == $this_plugin ){
		$settings_link = '<a href="options-general.php?page=super-cool-qrcodes/super-cool-qrcodes.php">' . __('Settings', $sqr_dom) . '</a>';
		$links[1] = $links[0];
		$links[0] = $settings_link;
	}
	return $links;
}

// OPTIONS PAGE
if ( is_admin() ) { add_action('admin_menu', 'sqr_menu'); }
function sqr_menu() {
	add_options_page(__('Super Cool QRCode',$sqr_dom), __('S. Cool QRCode',$sqr_dom), 8, __FILE__, 'sqr_options');
}
function sqr_options() {
global $sqr_dom;
$opt = get_option('sqr_options');
$plug_name = 'Super Cool QRCode';
$plug_ver = '0.0.6';
$plug_site = 'http://www.incerteza.org/blog/projetos/super-cool-qrcode/';
	if ( isset($_POST['update_options']) ) {
		if ( $_POST['sqr_form_ssize'] != '' && is_numeric($_POST['sqr_form_ssize']) ) { $opt['shortcode']['size'] = $_POST['sqr_form_ssize']; }
		if ( $_POST['sqr_form_wsize'] != '' && is_numeric($_POST['sqr_form_wsize']) ) { $opt['widget']['size'] = $_POST['sqr_form_wsize']; }
		if ( $_POST['sqr_form_senc'] == 'Shift_JIS' || $_POST['sqr_form_senc'] == 'UTF-8' || $_POST['sqr_form_senc'] == 'ISO-8859-1' ) { $opt['shortcode']['enc'] = $_POST['sqr_form_senc']; }
		if ( $_POST['sqr_form_wenc'] == 'Shift_JIS' || $_POST['sqr_form_wenc'] == 'UTF-8' || $_POST['sqr_form_wenc'] == 'ISO-8859-1' ) { $opt['widget']['enc'] = $_POST['sqr_form_wenc']; }
		$opt['shortcode']['ec'] = $_POST['sqr_form_sec'];
		$opt['widget']['ec'] = $_POST['sqr_form_wec'];
		if ( $_POST['sqr_form_smargin'] != '' && is_numeric($_POST['sqr_form_smargin']) ) { $opt['shortcode']['margin'] = $_POST['sqr_form_smargin']; }
		if ( $_POST['sqr_form_wmargin'] != '' && is_numeric($_POST['sqr_form_wmargin']) ) { $opt['widget']['margin'] = $_POST['sqr_form_wmargin']; }
		if ( $_POST['sqr_form_slink'] != '' && ($_POST['sqr_form_slink'] == 'true' || $_POST['sqr_form_slink'] == 'false' || strpos($_POST['sqr_form_slink'],'://') !== FALSE) ) { $opt['shortcode']['link'] = $_POST['sqr_form_slink']; }
		if ( $_POST['sqr_form_wlink'] != '' && ($_POST['sqr_form_wlink'] == 'true' || $_POST['sqr_form_wlink'] == 'false' || strpos($_POST['sqr_form_wlink'],'://') !== FALSE) ) { $opt['widget']['link'] = $_POST['sqr_form_wlink']; }
		$opt['shortcode']['target'] = $_POST['sqr_form_starget'];
		$opt['widget']['target'] = $_POST['sqr_form_wtarget'];
		if ( $_POST['sqr_form_sborder'] != '' && is_numeric($_POST['sqr_form_sborder']) ) { $opt['shortcode']['border'] = $_POST['sqr_form_sborder']; }
		if ( $_POST['sqr_form_wborder'] != '' && is_numeric($_POST['sqr_form_wborder']) ) { $opt['widget']['border'] = $_POST['sqr_form_wborder']; }
		update_option('sqr_options', $opt);
		echo '<div id="message" class="updated fade"><p><strong>' . __('Options saved.', $sqr_dom) . '</strong></p></div>';
	} else if (isset($_POST['reset_options'])) {
		$opt = sqr_default_opt();
		update_option('sqr_options', $opt);
		echo '<div id="message" class="updated fade"><p><strong>' . __('Default options loaded.', $sqr_dom) . '</strong></p></div>';
	}
?>
	<div class="wrap">
	<h2><?php echo __('Super Cool QRCode', $sqr_dom); ?></h2>
	<h2><?php echo __('Settings', $sqr_dom); ?></h2>
   	<h3><?php echo __('Default Options', $sqr_dom); ?></h3>
	<form method="post" name="options" target="_self">
    <p>This will be the default values of the Super Cool QRCode Shortcode and Widget.</p>
    <table width="100%" cellspacing="0" id="inactive-plugins-table" class="widefat">
      <thead><tr>
        <th width="100"><?php echo __('Field', $sqr_dom); ?></th>
        <th width="100"><?php echo __('Shortcode', $sqr_dom); ?></th>
        <th width="100"><?php echo __('Widget', $sqr_dom); ?></th>
        <th><?php echo __('Description', $sqr_dom); ?></th>
      </tr></thead>
      <tr>
        <td width="100"><?php echo __('Size', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_ssize" style="width:100%;" value="<?php echo $opt['shortcode']['size']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wsize" style="width:100%;" value="<?php echo $opt['widget']['size']; ?>" /></td>
        <td><?php echo __('The size of the generated QRCode image. it\'s always a square, so you only need to set one side.', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Encoding', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_senc" style="width:100%;" value="<?php echo $opt['shortcode']['enc']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wenc" style="width:100%;" value="<?php echo $opt['widget']['enc']; ?>" /></td>
        <td><?php echo __('Specifies how the output is encoded. Available encodings are Shift_JIS, UTF-8, or ISO-8859-1.', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Error correction', $sqr_dom); ?></td>
        <td width="100"><select name="sqr_form_sec" style="width:100%;">
                            <option value="L" <?php if ( $opt['shortcode']['ec'] == 'L' ) echo 'selected="selected"'; ?> /><?php echo __('L', $sqr_dom); ?></option>
                            <option value="M" <?php if ( $opt['shortcode']['ec'] == 'M' ) echo 'selected="selected"'; ?> /><?php echo __('M', $sqr_dom); ?></option>
                            <option value="Q" <?php if ( $opt['shortcode']['ec'] == 'Q' ) echo 'selected="selected"'; ?> /><?php echo __('Q', $sqr_dom); ?></option>
                            <option value="H" <?php if ( $opt['shortcode']['ec'] == 'H' ) echo 'selected="selected"'; ?> /><?php echo __('H', $sqr_dom); ?></option>
        </select></td>
        <td width="100"><select name="sqr_form_wec" style="width:100%;">
                            <option value="L" <?php if ( $opt['widget']['ec'] == 'L' ) echo 'selected="selected"'; ?> /><?php echo __('L', $sqr_dom); ?></option>
                            <option value="M" <?php if ( $opt['widget']['ec'] == 'M' ) echo 'selected="selected"'; ?> /><?php echo __('M', $sqr_dom); ?></option>
                            <option value="Q" <?php if ( $opt['widget']['ec'] == 'Q' ) echo 'selected="selected"'; ?> /><?php echo __('Q', $sqr_dom); ?></option>
                            <option value="H" <?php if ( $opt['widget']['ec'] == 'H' ) echo 'selected="selected"'; ?> /><?php echo __('H', $sqr_dom); ?></option>
        </select></td>
        <td><?php echo __('Error correction level:<br/><strong>L</strong> allows 7% of a QR code to be restored<br/><strong>M</strong> allows 15% of a QR code to be restored<br/><strong>Q</strong> allows 25% of a QR code to be restored<br/><strong>H</strong> allows 30% of a QR code to be restored<br/>More info <a href="http://code.google.com/apis/chart/types.html#ec_level_table" target="_blank">here</a>.', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Margin', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_smargin" style="width:100%;" value="<?php echo $opt['shortcode']['margin']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wmargin" style="width:100%;" value="<?php echo $opt['widget']['margin']; ?>" /></td>
        <td><?php echo __('Defines the margin (or blank space) around the QR code.', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Link', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_slink" style="width:100%;" value="<?php echo $opt['shortcode']['link']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wlink" style="width:100%;" value="<?php echo $opt['widget']['link']; ?>" /></td>
        <td><?php echo __('Define if the image will have a link:<br/><strong>False</strong> for no link<br/><strong>True</strong> for link to the QR code image<br/><strong>http://</strong> for a link to some URL (ex: http://www.google.com).', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Target', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_starget" style="width:100%;" value="<?php echo $opt['shortcode']['target']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wtarget" style="width:100%;" value="<?php echo $opt['widget']['target']; ?>" /></td>
        <td><?php echo __('The target attribute of the link (ex: _blank).', $sqr_dom); ?></td>
      </tr>
      <tr>
        <td width="100"><?php echo __('Border', $sqr_dom); ?></td>
        <td width="100"><input type="text" name="sqr_form_sborder" style="width:100%;" value="<?php echo $opt['shortcode']['border']; ?>" /></td>
        <td width="100"><input type="text" name="sqr_form_wborder" style="width:100%;" value="<?php echo $opt['widget']['border']; ?>" /></td>
        <td><?php echo __('The border thickness of the linked image.', $sqr_dom); ?></td>
      </tr>
    </table>
 	<p class="submit"><input type="submit" name="update_options" class="button-primary" value="<?php echo __('Save Changes', $sqr_dom); ?>" /> <input type="submit" name="reset_options" value="<?php echo __('Reset Options', $sqr_dom); ?>" /></p>
	</form>
   	<h3><?php echo __('Using the Shortcode', $sqr_dom); ?></h3>
	<p><?php echo __('If you simply use <strong>[sqrcode]</strong> a QR code with a link to the current URL will be rendered, if you use <strong>[sqrcode]</strong><em>content</em><strong>[/sqrcode]</strong> a QR code with <em>content</em> will be rendered.', $sqr_dom); ?></p>
    <p><?php echo __('You can overwrite any default value passing it as a parameter in the shortcode, ex: <strong>[sqrcode size="150" link="true"]</strong><em>content</em><strong>[/sqrcode]</strong>, will render a QR code with 150px of side with a link to the QR code image.', $sqr_dom); ?></p>
	<h3><?php echo __('Using the PHP Function', $sqr_dom); ?></h3>
    <p><?php echo __('There is the <em>sqr_url()</em> PHP function who return the URL of the QR code image, the only obligatory parameter is the string to be encoded.', $sqr_dom); ?></p>
    <p><?php echo __('<em>sqr_url("string")</em> - Passing just the string to be encoded<br/><em>sqr_url("string","size","encode","error","margin")</em> - Passing all the parameters', $sqr_dom); ?></p>
	<p><?php echo __('Remember that this function will only return the URL of the image, so if you want to show the image itself you have to enclose it in the image tag.', $sqr_dom); ?></p>
	<h3><?php echo __('Usefull Links', $sqr_dom); ?></h3>
    <p><?php echo __('<a rel="nofollow" href="http://zxing.org/w/decode.jspx" target="_blank">ZXing Decoder Online</a>: decode your QR code in a online interface<br /><a rel="nofollow" href="http://code.google.com/apis/chart/" target="_blank">Google Chart API</a>: the API used by this plugin to generate the codes', $sqr_dom); ?></p>
    <hr />
	<p><?php echo __('<strong>Note</strong>: i\'m learning PHP & Wordpress coding and using this plugin to study, so if you have any idea or any kind of suggestion please contact me.', $sqr_dom); ?></p>
	<p><?php echo '<a href="' . $plug_site . '">' . $plug_name . ' v' . $plug_ver . '</a> ' . __('by', $sqr_dom) . ' <a href="mailto:matias@incerteza.org">matias s.</a> ' . __('at', $sqr_dom) . ' <a href="http://www.incerteza.org/blog/" target="_blank" rel="nofollow">incerteza.org</a>'; ?></p>
    </div>
<?php
}
?>